/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 272 - (show annotations)
Fri Sep 9 18:27:11 2011 UTC (12 years, 7 months ago) by dpavlin
File MIME type: application/x-sh
File size: 6073 byte(s)
fallback for lxc-info 0.7.2
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43 lxc_hostname() {
44 inside=`cat $(lxc_rootfs $1)/etc/hostname`
45 config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46 echo "$config [$inside]";
47 }
48
49 lxc_ip() {
50 ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51 grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52 head -1 | \
53 sed -e 's/ *//g' -e 's/\/.*$//'
54 }
55
56 lxc_status() {
57 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58 status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2` # 0.7.5
59 test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60 boot="-"
61 test -s /var/lib/lxc/$name/on_boot && boot="boot"
62 echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
63 done ) | column -t
64 }
65
66
67 cleanup_init_scripts() {
68 rootfs=$(lxc_rootfs $1)
69
70 ls \
71 $rootfs/etc/rc?.d/*checkroot* \
72 $rootfs/etc/rc?.d/*umountfs \
73 $rootfs/etc/rc?.d/*umountroot \
74 $rootfs/etc/rc?.d/*hwclock* \
75 $rootfs/etc/rc?.d/*udev* \
76 $rootfs/etc/rc?.d/*checkfs* \
77 2>/dev/null | xargs -i rm -v {}
78
79 echo $1 > $rootfs/etc/hostname
80 grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81 }
82
83
84 setup_inittab() {
85 rootfs=$(lxc_rootfs $1)
86 remove=$2
87 add=$3
88
89 # let container respond to kill -SIGPWR
90 inittab=$rootfs/etc/inittab
91 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
92 grep -v "$remove" ${inittab} > ${inittab}.new
93 echo $add >> ${inittab}.new
94 mv ${inittab}.new ${inittab}
95 echo "$inittab modified with $add"
96 fi
97 }
98
99
100 lxc_log() {
101 echo `date +%Y-%m-%dT%H:%M:%S` $*
102 }
103
104
105 lxc_kill() {
106 name=$1
107 sig=$2
108
109 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
110 if [ -z "$init_pid" ] ; then
111 lxc-info -n $name
112 exit 1
113 fi
114 lxc_log "$name kill $sig $init_pid"
115 /bin/kill $sig $init_pid
116 }
117
118 lxc_stop() {
119 lxc_log "$name stop"
120 lxc_kill $name -SIGPWR
121 lxc-wait -n $name -s STOPPED
122 lxc_log "$name stoped"
123 # rm -f /var/lib/lxc/${name}/on_boot
124 }
125
126
127 lxc_start() {
128 name=$1
129 rootfs=$(lxc_rootfs $1)
130
131 if [ ! -e $rootfs ] ; then
132 echo "ERROR $name rootfs $rootfs not found"
133 return
134 fi
135
136 if ! lxc-info -n $name | grep RUNNING ; then
137 lxc_log "$name start"
138 dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
139 mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
140 lxc-start -n $name -o /tmp/${name}.log -d
141 lxc-wait -n $name -s RUNNING
142 lxc-info -n $name
143 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
144 fi
145 }
146
147 lxc_watchdog() {
148 name=$1
149 rootfs=$(lxc_rootfs $1)
150 run=$rootfs/var/run
151 test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
152 cd $run || echo "can't cd watchdog into $run"
153
154 while true; do
155 tasks=`wc -l < /cgroup/${name}/tasks`
156 stop_on=1 # init
157 sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
158 if [ "$sulogins" -gt 0 ] ; then
159 stop_on=`expr $stop_on + $sulogins`
160 fi
161
162 test -z "$tasks" && exit 1
163 if [ "$tasks" -eq $stop_on ]; then
164
165 runlevel="$(runlevel utmp)"
166 lxc_log "$name runlevel $runlevel"
167
168 case $runlevel in
169 N*)
170 # nothing for new boot state
171 ;;
172 ??0|unknown)
173 lxc_log "$name halt"
174 lxc-stop -n "${name}"
175 lxc-wait -n ${name} -s STOPPED
176 break
177 ;;
178 ??6)
179 lxc_log "$name reboot";
180 lxc-stop -n ${name}
181 lxc-wait -n ${name} -s STOPPED
182 lxc-start -d -n ${name} -o /tmp/${name}.log
183 ;;
184 *)
185 # make sure vps is still running
186 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
187 [ "$state" = "RUNNING" ] || break
188 ;;
189 esac
190 else
191 lxc_log "$name $tasks tasks $sulogins console"
192 fi
193
194 # time of 5 minutes on it JUST IN CASE...
195 inotifywait -qqt 300 utmp
196 done
197
198 lxc_log "$name watchdog exited"
199
200 }
201
202
203 usage() {
204 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
205 exit 3
206 }
207
208 command_on_lxc() {
209 command=$1
210 shift
211
212 echo "# $command $1"
213
214 case "$command" in
215
216 start)
217 lxc_exists $1
218 cleanup_init_scripts $1
219 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
220 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
221 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
222 lxc_start $1
223 # give container 5 seconds to start more than one process
224 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
225 ;;
226 stop|halt)
227 lxc_exists $1
228 lxc_stop $1
229 ;;
230 reload|force-reload|restart|reboot)
231 lxc_kill $1 -SIGINT
232 ;;
233 watchdog)
234 lxc_watchdog $1
235 ;;
236 boot)
237 echo $1 > /var/lib/lxc/$1/on_boot
238 ;;
239 disable)
240 echo -n > /var/lib/lxc/$1/on_boot
241 ;;
242 *)
243 usage
244 ;;
245
246 esac
247
248 }
249
250 command=$1
251 test -z "$command" && usage
252 test "$command" = "status" && lxc_status && exit
253 shift
254
255 if [ -z "$1" ] ; then
256 ls /var/lib/lxc/*/on_boot | while read path ; do
257 name=`echo $path | cut -d/ -f5`
258 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
259 command_on_lxc $command $name
260 else
261 echo "# skip $command $name"
262 fi
263 done
264 else
265 while [ ! -z "$1" ] ; do
266 command_on_lxc $command $1
267 shift
268 done
269 fi
270

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26